< prev index next >

test/hotspot/jtreg/runtime/LoaderConstraints/itableLdrConstraint/Test.java

Print this page

        

*** 33,67 **** * @run main/othervm Test */ public class Test { ! // Break expected error messages into 2 parts since the loader name includes its identity // hash which is unique and can't be compared against. ! static String expectedErrorMessage1_part1 = ! "loader constraint violation in interface itable initialization for class test.C: " + ! "when selecting method test.I.m()Ltest/Foo; " + ! "the class loader PreemptingClassLoader @"; ! static String expectedErrorMessage1_part2 = ! " (instance of PreemptingClassLoader, " + ! "child of 'app' jdk.internal.loader.ClassLoaders$AppClassLoader) " + ! "for super interface test.I, and the class loader 'app' " + ! "(instance of jdk.internal.loader.ClassLoaders$AppClassLoader) " + ! "of the selected method's type, test.J have different Class objects " + ! "for the type test.Foo used in the signature"; ! static String expectedErrorMessage2_part1 = ! "loader constraint violation in interface itable initialization for class test.C: " + ! "when selecting method test.I.m()Ltest/Foo; " + ! "the class loader 'ItableLdrCnstrnt_Test_Loader' @"; ! static String expectedErrorMessage2_part2 = ! " (instance of PreemptingClassLoader, " + ! "child of 'app' jdk.internal.loader.ClassLoaders$AppClassLoader) " + ! "for super interface test.I, and the class loader 'app' " + ! "(instance of jdk.internal.loader.ClassLoaders$AppClassLoader) " + ! "of the selected method's type, test.J have different Class objects " + ! "for the type test.Foo used in the signature"; // Test that the error message is correct when a loader constraint error is // detected during itable creation. // // In this test, during itable creation for class C, method "m()LFoo;" for --- 33,61 ---- * @run main/othervm Test */ public class Test { ! // Break expected error messages into 3 parts since the loader name includes its identity // hash which is unique and can't be compared against. ! static String expectedErrorMessage1_part1 = "loader constraint violation in interface itable initialization for " + ! "class test.C: when selecting method test.I.m()Ltest/Foo; the class loader " + ! "PreemptingClassLoader @"; ! static String expectedErrorMessage1_part2 = " for super interface test.I, and the class loader 'app' of the " + ! "selected method's type, test.J have different Class objects for the " + ! "type test.Foo used in the signature (test.I is in unnamed module of loader " + ! "PreemptingClassLoader @"; ! static String expectedErrorMessage1_part3 = ", parent loader 'app'; test.J is in unnamed module of loader 'app')"; ! static String expectedErrorMessage2_part1 = "loader constraint violation in interface itable initialization for " + ! "class test.C: when selecting method test.I.m()Ltest/Foo; the class loader " + ! "'ItableLdrCnstrnt_Test_Loader' @"; ! static String expectedErrorMessage2_part2 = " for super interface test.I, and the class loader 'app' of the " + ! "selected method's type, test.J have different Class objects for the " + ! "type test.Foo used in the signature (test.I is in unnamed module of loader " + ! "'ItableLdrCnstrnt_Test_Loader' @"; ! static String expectedErrorMessage2_part3 = ", parent loader 'app'; test.J is in unnamed module of loader 'app')"; // Test that the error message is correct when a loader constraint error is // detected during itable creation. // // In this test, during itable creation for class C, method "m()LFoo;" for
*** 69,98 **** // type super interface J. The selected method is not an overpass method nor // otherwise excluded from loader constraint checking. So, a LinkageError // exception should be thrown because the loader constraint check will fail. public static void test(String loaderName, String expectedErrorMessage_part1, ! String expectedErrorMessage_part2) throws Exception { Class<?> c = test.Foo.class; // Forces standard class loader to load Foo. String[] classNames = {"test.Task", "test.Foo", "test.C", "test.I"}; ClassLoader l = new PreemptingClassLoader(loaderName, classNames); Runnable r = (Runnable) l.loadClass("test.Task").newInstance(); try { r.run(); throw new RuntimeException("Expected LinkageError exception not thrown"); } catch (LinkageError e) { String errorMsg = e.getMessage(); if (!errorMsg.contains(expectedErrorMessage_part1) || ! !errorMsg.contains(expectedErrorMessage_part2)) { System.out.println("Expected: " + expectedErrorMessage_part1 + "<id>" + expectedErrorMessage_part2 + "\n" + "but got: " + errorMsg); throw new RuntimeException("Wrong LinkageError exception thrown: " + errorMsg); } System.out.println("Passed with message: " + errorMsg); } } public static void main(String... args) throws Exception { ! test(null, expectedErrorMessage1_part1, expectedErrorMessage1_part2); ! test("ItableLdrCnstrnt_Test_Loader", expectedErrorMessage2_part1, expectedErrorMessage2_part2); } } --- 63,94 ---- // type super interface J. The selected method is not an overpass method nor // otherwise excluded from loader constraint checking. So, a LinkageError // exception should be thrown because the loader constraint check will fail. public static void test(String loaderName, String expectedErrorMessage_part1, ! String expectedErrorMessage_part2, ! String expectedErrorMessage_part3) throws Exception { Class<?> c = test.Foo.class; // Forces standard class loader to load Foo. String[] classNames = {"test.Task", "test.Foo", "test.C", "test.I"}; ClassLoader l = new PreemptingClassLoader(loaderName, classNames); Runnable r = (Runnable) l.loadClass("test.Task").newInstance(); try { r.run(); throw new RuntimeException("Expected LinkageError exception not thrown"); } catch (LinkageError e) { String errorMsg = e.getMessage(); if (!errorMsg.contains(expectedErrorMessage_part1) || ! !errorMsg.contains(expectedErrorMessage_part2) || ! !errorMsg.contains(expectedErrorMessage_part3)) { System.out.println("Expected: " + expectedErrorMessage_part1 + "<id>" + expectedErrorMessage_part2 + "\n" + "but got: " + errorMsg); throw new RuntimeException("Wrong LinkageError exception thrown: " + errorMsg); } System.out.println("Passed with message: " + errorMsg); } } public static void main(String... args) throws Exception { ! test(null, expectedErrorMessage1_part1, expectedErrorMessage1_part2, expectedErrorMessage1_part3); ! test("ItableLdrCnstrnt_Test_Loader", expectedErrorMessage2_part1, expectedErrorMessage2_part2, expectedErrorMessage2_part3); } }
< prev index next >